unit MainUn;
(*
: Su Doku
Author:   aka Shurik7777
web: shurik7777.narod.ru
mail: shurik7777@mail.ru
jabber: shurik7777@jabber.ru
 : 0.1
: 19.02.2009
: Delphi


Su Doku -  !
 -     .
    ,
      .

      9*9 ( [,] )
      SudocuMask
      SudocuMap (   )
      SudocuBtn
           
 ,    - ,   - 
       SetSudocuCell
           ( 
 ),          
.  " " :-). ... : - 
      :-).
     ,     ,  
  .

     .   .
      .
             .
   ,         -   ,
      .       
 .
     :
     (),  ()   3*3 ( ).
    -       1  9   .
    [1..9]    //  
  .      ,
 .      .
          .  
  /  ,    
     .

  -     TButton   TSpeedButton
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Buttons;

type
  TMainForm = class(TForm)
    EditLbl: TLabel;
    PopupMenu1: TPopupMenu;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    Empty1: TMenuItem;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    SaveDlg: TSaveDialog;
    OpenDlg: TOpenDialog;
    N1: TMenuItem;
    EditModeMenu: TMenuItem;
    CheatModeMenu: TMenuItem;
    GameModeMenu: TMenuItem;
    ResetMenu: TMenuItem;
    About1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MenuClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure EditModeMenuClick(Sender: TObject);
    procedure GameModeMenuClick(Sender: TObject);
    procedure CheatModeMenuClick(Sender: TObject);
    procedure ResetMenuClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure OnBtnClick(Sender:TObject);
    procedure NewMap;
    procedure SetSuDokuCell(x,y,n:integer);
    procedure SetGameMode(cheat:boolean);
    procedure SetEditmode;
    procedure SetMenu;
    procedure CheckMap;
  end;

procedure SetTaskStyle(Btn:TSpeedButton);
procedure SetGameStyle(Btn:TSpeedButton);

const
  AboutStr='Su Doku'+#10+' 0.1 (19.02.2009)'+#10+':  . aka Shurik7777'
    +#10+'web: http://shurik7777.narod.ru'
    +#10+'email: shurik7777@mail.ru'+#10+'jabber: shurik7777@jabber.ru';

var
  MainForm: TMainForm;
  SuDokuBtn:array[0..8,0..8] of TSpeedButton; //   
  SuDokuMap:array[0..8,0..8] of Integer; //   
  SuDokuMask:array[0..8,0..8] of Integer; //  
  EditMode:boolean; //  
  CheatMode:boolean; //  
  SelectBtn:TSpeedButton; //  
  SelectX,SelectY:integer; //   
  CellCount:integer; //        
implementation

{$R *.DFM}

//   
procedure TMainForm.FormCreate(Sender: TObject);
var i,j,k,l:integer;
  tmpP:TPanel;  //  
  tmpB:TSpeedButton; // 
begin
  for j:=0 to 2 do //   - 
    for i:=0 to 2 do begin // -- 
      tmpP:=TPanel.Create(Self);
      tmpP.Parent:=Self;
      tmpP.height:=98;
      tmpP.width:=98;
      tmpP.left:=i*98+32;
      tmpP.top:=j*98+16;
      tmpP.BorderStyle:=bsSingle;
      tmpP.Ctl3D:=false;
      tmpP.BevelInner:=bvNone;
      tmpP.BevelOuter:=bvNone;
      for l:=0 to 2 do // 
        for k:=0 to 2 do begin // 
(*  -
        :
   0:3 - 
       4:7 - 
*)
          tmpB:=TSpeedButton.Create(Self);
          tmpB.Parent:=tmpP;
          tmpB.Tag:=(i*3+k)+((j*3+l)shl 4); //  
          tmpB.height:=32;
          tmpB.width:=32;
          tmpB.left:=k*32;
          tmpB.top:=l*32;
          SuDokuBtn[j*3+l,i*3+k]:=tmpB;
          tmpB.OnClick:=OnBtnClick;
//    tmpB.Caption:=IntToStr((tmpB.Tag and $F0)shr 4)+IntToStr(tmpB.Tag and $0F);
        end;
    end;
  NewMap; //   
end;

//    
procedure TMainForm.OnBtnClick(Sender: TObject);
var
  cur:TPoint;
begin
  //    
  SelectBtn:=(Sender as TSpeedButton);
  SelectX:=SelectBtn.Tag and $0F;
  SelectY:=(SelectBtn.Tag and $F0 shr 4);
  (*    
       - 
       -   
  *)
  if (not EditMode)and(SuDokuMask[SelectY,SelectX]<>0) then exit;
  GetCursorPos(cur);
  SetMenu; //  
  PopupMenu1.Popup(cur.x,cur.y);
end;

//  
procedure TMainForm.MenuClick(Sender: TObject);
var i:integer;
begin
  i:=(Sender as TMenuItem).MenuIndex;
  SetSuDokuCell(SelectX,SelectY,i);
  if CellCount=81 then begin // -  !
    CheckMap;
  end;
end;

procedure TMainForm.New1Click(Sender: TObject);
begin
  NewMap
end;

(*   ,        *)
procedure TMainForm.NewMap;
var i,j:integer;
begin
  SetEditMode;
  for j:=0 to 8 do
    for i:=0 to 8 do begin
      SetSuDokuCell(i,j,0);
    end;
  //        :
  CellCount:=0;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TMainForm.SaveAs1Click(Sender: TObject);
var fOut:textfile;
  i,j:integer;
  str:string[9];
begin
  If not SaveDlg.Execute then exit;
  AssignFile(fOut,SaveDlg.FileName);
  Rewrite(fOut);
  SetLength(str,9);
  for j:=0 to 8 do begin
    for i:=0 to 8 do str[i+1]:=Chr(SuDokuMask[j,i]+48);
    Writeln(fOut,str);
  end;
  CloseFile(fOut);
end;

//  
procedure TMainForm.Open1Click(Sender: TObject);
var fIn:textfile;
  i,j:integer;
  str:string[9];
  err:boolean; //  -   ,   !
  n:integer;
begin
  if not OpenDlg.Execute then exit;
  NewMap; //      
  err:=false;
  AssignFile(fIn,OpenDlg.Filename);
  try
    Reset(fIn);
  for j:=0 to 8 do begin //  
    if eof(fIn)then begin
      err:=true; break;
    end;
    Readln(fIn,str);
    if length(str)<>9 then begin
      err:=true; break;
    end;
    for i:=0 to 8 do begin
      n:=ord(str[i+1])-48;
      if(n<0) or (n>9) then begin
        err:=true; break;
      end;
    //   ,  
      SetSuDokuCell(i,j,n);
    end;
  end;
  if err then ShowMessage('Wrong file!');
  //    
  SetGameMode(false);
  finally
    closeFile(fIn);
  end;
end;

//    
procedure SetTaskStyle(Btn:TSpeedButton);
begin
  Btn.Font.Size:=14;
  Btn.Font.Style:=[fsBold];
  Btn.Font.Color:=clBlack; //      -  
end;

//     ()
procedure SetGameStyle(Btn:TSpeedButton);
begin
  Btn.Font.Size:=12;
  Btn.Font.Style:=[];
  Btn.Font.Color:=clBlack;
end;


(*  
      -   
   ( ):
  x,y=0..8
  n=0..9
*)
procedure TMainForm.SetSuDokuCell(x, y, n: integer);
begin
  //     !
  if(n>0)and(SuDokuMap[y,x]=0) then inc(CellCount)
  else
    if(n=0)and(SuDokuMap[y,x]>0) then dec(CellCount);
  SuDokuMap[y,x]:=n;
  if EditMode then SuDokuMask[y,x]:=n;
  if n=0 then begin // 0     (    )
    SuDokuBtn[y,x].Caption:=' ';
    //   ,    SetGameStyle(SuDokuBtn[y,x]);
  end
  else begin
    if EditMode then SetTaskStyle(SuDokuBtn[y,x])
    else SetGameStyle(SuDokuBtn[y,x]);
    SuDokuBtn[y,x].Caption:=chr(n+48);
  end;

end;

//   
procedure TMainForm.SetEditmode;
begin
  EditMode:=true;
  EditLbl.Caption:=EditModeMenu.Caption;
  ResetMenu.Enabled:=false; //  ?   !
  EditModeMenu.Checked:=true;
end;

//    ( /)
procedure TMainForm.SetGameMode(cheat:boolean);
begin
  EditMode:=false;
  CheatMode:=cheat;
  ResetMenu.Enabled:=true; //    
  if cheat then begin
    CheatModeMenu.Checked:=true;
    EditLbl.Caption:=CheatModeMenu.Caption;
  end
  else begin
    GameModeMenu.Checked:=true;
    EditLbl.Caption:=GameModeMenu.Caption;
  end;
end;

(*        
      SelectX  SelectY!
*)
procedure TMainForm.SetMenu;
var i,j,k,l,n:integer;
begin
  //   
  for i:=1 to 9 do PopUpMenu1.Items[i].Enabled:=true;
  if not (CheatMode or EditMode) then exit; //  !
  // 
  for i:=0 to 8 do begin
    n:=SuDokuMap[SelectY,i];
    if n<>0 then PopUpMenu1.Items[n].Enabled:=false;
  end;
  // 
  for i:=0 to 8 do begin
    n:=SuDokuMap[i,SelectX];
    if n<>0 then PopUpMenu1.Items[n].Enabled:=false;
  end;
  // 
  k:=SelectX-(SelectX mod 3);//  (x div 3)*3
  l:=SelectY-(SelectY mod 3);
  for j:=0 to 2 do
    for i:=0 to 2 do begin
      n:=SuDokuMap[l+j,k+i];
      if n<>0 then PopUpMenu1.Items[n].Enabled:=false;
    end;
end;

procedure TMainForm.EditModeMenuClick(Sender: TObject);
begin
  SetEditMode;
end;

procedure TMainForm.GameModeMenuClick(Sender: TObject);
begin
  SetGameMode(false);
end;

procedure TMainForm.CheatModeMenuClick(Sender: TObject);
begin
  SetGameMode(true);
end;

(*    
    -    *)
procedure TMainForm.ResetMenuClick(Sender: TObject);
var i,j:integer;
begin
  for j:=0 to 8 do
    for i:=0 to 8 do
      if SuDokuMask[j,i]=0 then SetSuDokuCell(i,j,0);
end;

(*      
   -  1..9   
  ,   $3FE (11'1111'1110)
*)
procedure TMainForm.CheckMap;
var i,j,k,l,n:integer;
  check:word;
  error:integer;
begin
  error:=0;
//  
  for j:=0 to 8 do begin
    check:=0;
    for i:=0 to 8 do begin
      //     
      if SuDokuMask[j,i]=0 then SuDokuBtn[j,i].Font.Color:=clBlack;
      check:=check or (1 shl SuDokuMap[j,i]);
    end;
    if check<>$3FE then begin //  
      inc(error);
      for i:=0 to 8 do // 
        if SuDokuMask[j,i]=0 then SuDokuBtn[j,i].Font.Color:=clRed;
    end;
  end;
//  
  for j:=0 to 8 do begin
    check:=0;
    for i:=0 to 8 do begin
      check:=check or (1 shl SuDokuMap[i,j]);
    end;
    if check<>$3FE then begin //  
      inc(error);
      for i:=0 to 8 do // 
        if SuDokuMask[i,j]=0 then SuDokuBtn[i,j].Font.Color:=clRed;
    end;
  end;
//   
  for l:=0 to 2 do
    for k:=0 to 2 do begin
      check:=0;
      for j:=0 to 2 do
        for i:=0 to 2 do
          check:=check or (1 shl SuDokuMap[j+l*3,i+k*3]);
      if check<>$3FE then begin //  
        inc(error);
        for j:=0 to 2 do // 
          for i:=0 to 2 do
            if SuDokuMask[j+l*3,i+k*3]=0 then SuDokuBtn[j+l*3,i+k*3].Font.Color:=clRed;
      end;
    end;
  if error=0 then  ShowMessage(' ')
  else ShowMessage('  ');
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  ShowMessage(AboutStr);
end;

end.
